<template>
  <modal name="modalNewLibrary" clickToClose adaptive height="auto">
    <div class="modal-container">
      <div class="modal-header">
        <h3>New Library</h3>
        <button
          type="button"
          class="close"
          @click="$modal.hide('modalNewLibrary')"
          data-dismiss="modal"
          aria-label="Close"
        >
          <font-awesome-icon color="firebrick" icon="times" size="lg"/>
        </button>
      </div>
      <div class="modal-body">
        <div class="row">
          <div class="col-5">
            <h5>Server :</h5>
            <select class="form-control form-control-sm" v-model="selectedServer">
              <template v-if="(servers.length>0)">
                <option v-for="(server, key) in servers" :key="key" :value="server" v-if="user.id==server.userId">{{server.name}}</option>
              </template>
              <template v-else> <b-alert>No servers available </b-alert> </template>
            </select>
            <h5 class="mt-3">Name :</h5>
            <input type="text" v-model="libraryName" class="form-control input-border-less" placeholder="Library name" aria-label="libraryname">
          </div>
          <div class="col-7">
            <fileExplorer :server="selectedServer" @libraryFolder="(libraryPath)=>selectFolder(libraryPath)"></fileExplorer>
          </div>
        </div>
      </div>
    </div>
          <div class="modal-footer">
        <button @click="addLibrary()" type="button" class="btn btn-primary">Add Library </button>
      </div>
  </modal>
</template>

<script>
import fileExplorer from '../user_board/FileExplorer'
import { library } from '@fortawesome/fontawesome-svg-core';
export default {
  name :'modalNewLibrary',
  components:{
    fileExplorer
  },
  props:['servers'],
  data(){
    return {
      token :localStorage.getItem("jwt"),
      user: JSON.parse(localStorage.getItem("user")),
      selectedServer:'',
      libraryName:null,
      libraryPath:null,
     }
  },
  mounted(){
      if(this.servers.length>0) this.selectedServer=this.servers[0]
      this.$socket.on('resNewLibrary',(data)=>{
        if(!data.error){
          this.$emit('addLibrary',{library:data.library,serverId:this.selectedServer.id});
          this.libraryName=null
          this.$toastr.info("Now ,you can see the new library "+ data.library.name +" in the libraries panel", "Library added", {
          preventDuplicates: true,
          progressBar: true
        });
          this.$modal.hide('modalNewLibrary')
        }else{
        this.$toastr.error("Error : Check library name, must by unique for this server" , "Error creating library", {
          preventDuplicates: true,
          progressBar: true
        });
        }
      })
  },
  methods : {
    addLibrary(libraryPath){
      if(this.libraryPath!=null){
        if(this.libraryName!=null){
          this.$socket.emit('reqNewLibrary',{
            userId:this.user.id,
            serverId:this.selectedServer.id,
            libraryName:this.libraryName,
            libraryPath:this.libraryPath,
            token:this.token
            })

        }else{
          this.$toastr.error("Please, type a name for the new library", "Error", {
                preventDuplicates: true,
                 progressBar: true
              });
        }
      }else{
          this.$toastr.error("Please, select a folder in one of your servers to place library", "Error", {
            preventDuplicates: true,
            progressBar: true
            });
      }
    },
    selectFolder(libraryPath){
      this.libraryPath=libraryPath   }
  },

}
</script>
